org.apache.tinkerpop.gremlin.process.traversal.util

## Class ImmutableExplanation

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.util.AbstractExplanation
  - - org.apache.tinkerpop.gremlin.process.traversal.util.TraversalExplanation
    - - org.apache.tinkerpop.gremlin.process.traversal.util.ImmutableExplanation

- All Implemented Interfaces:
    Serializable

      public class ImmutableExplanation
      extends TraversalExplanation

  A data-only representation of a `TraversalExplanation` which doesn't re-calculate the "explanation" from the raw traversal data each time the explanation is displayed.
  Author:
    Stephen Mallette (http://stephen.genoprime.com)
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.util.TraversalExplanation

      `strategyTraversals, traversal`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ImmutableExplanation(String originalTraversal, List<org.javatuples.Triplet<String,String,String>> intermediates)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ImmutableExplanation` | `asImmutable()`
    `protected Stream<org.javatuples.Triplet<String,String,String>>` | `getIntermediates()` First string is the traversal strategy, the second is the category and the third is the traversal representation at that point.
    `Traversal.Admin<?,?>` | `getOriginalTraversal()` Get the original `Traversal` used to create this explanation.
    `protected String` | `getOriginalTraversalAsString()`
    `List<org.javatuples.Pair<TraversalStrategy,Traversal.Admin<?,?>>>` | `getStrategyTraversals()` Get the list of `TraversalStrategy` applications.
    `protected Stream<String>` | `getStrategyTraversalsAsString()`
    `protected Stream<String>` | `getTraversalStepsAsString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.util.AbstractExplanation

      `prettyPrint, prettyPrint, spacing, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ImmutableExplanation

          public ImmutableExplanation(String originalTraversal,
                                      List<org.javatuples.Triplet<String,String,String>> intermediates)

  - ### Method Detail

    - #### getStrategyTraversals

          public List<org.javatuples.Pair<TraversalStrategy,Traversal.Admin<?,?>>> getStrategyTraversals()

      Description copied from class: `TraversalExplanation`
      Get the list of `TraversalStrategy` applications. For strategy, the resultant mutated `Traversal` is provided.
      Overrides:
        `getStrategyTraversals` in class `TraversalExplanation`
      Returns:
        the list of strategy/traversal pairs

    - #### getOriginalTraversal

          public Traversal.Admin<?,?> getOriginalTraversal()

      Description copied from class: `TraversalExplanation`
      Get the original `Traversal` used to create this explanation.
      Overrides:
        `getOriginalTraversal` in class `TraversalExplanation`
      Returns:
        the original traversal

    - #### asImmutable

          public ImmutableExplanation asImmutable()

      Overrides:
        `asImmutable` in class `TraversalExplanation`

    - #### getStrategyTraversalsAsString

          protected Stream<String> getStrategyTraversalsAsString()

      Overrides:
        `getStrategyTraversalsAsString` in class `TraversalExplanation`

    - #### getTraversalStepsAsString

          protected Stream<String> getTraversalStepsAsString()

      Overrides:
        `getTraversalStepsAsString` in class `AbstractExplanation`

    - #### getOriginalTraversalAsString

          protected String getOriginalTraversalAsString()

      Overrides:
        `getOriginalTraversalAsString` in class `TraversalExplanation`

    - #### getIntermediates

          protected Stream<org.javatuples.Triplet<String,String,String>> getIntermediates()

      Description copied from class: `AbstractExplanation`
      First string is the traversal strategy, the second is the category and the third is the traversal representation at that point.
      Overrides:
        `getIntermediates` in class `TraversalExplanation`

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.